"""
Test suite for TexisXMLRequest product

Uses ZopeTestCase - see http://zope.org/Members/shh/ZopeTestCaseWiki/FrontPage
"""
# 	$Id: testTexisXMLRequest.py,v 1.6 2004/05/10 16:33:52 davidc Exp $	

test_product = 'TexisXMLRequest'
test_id      = 'obj'
test_title   = 'Test'
test_url     = 'http://gilmour.lib.duke.edu/texis/xmlrequest/test/main.xml'
test_param   = '39e22bff12'
test_results = [{u'fname':u'David', u'lname':u'Chandek-Stark'}]
error_url      = 'http://gilmour.lib.duke.edu/texis/xmlrequest/test/error.xml'

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase

ZopeTestCase.installProduct(test_product)

app = ZopeTestCase.app()


class TestTexisXMLRequest(ZopeTestCase.ZopeTestCase):

    def afterSetUp(self):
        dispatcher = self.folder.manage_addProduct[test_product]
        dispatcher.manage_addTexisXMLRequest(id=test_id, title=test_title, url=test_url)
        self.obj = self.folder[test_id]

    def test_getResults(self):
        self.obj.editTexisXMLRequest(title=self.obj.title, url=test_url)
#        request = self.app.REQUEST
        results = self.obj(id=test_param)                                # good parameter value
        self.assert_(len(results) == 1)
        self.assertEqual(results[0], test_results[0])
        results = self.obj(id='foo')                                      # bad parameter value
        self.failIf(results)
        self.obj.editTexisXMLRequest(title=self.obj.title, url=error_url) # Texis error
        self.failIf(self.obj())

    def test_introspection(self):
        import Products.TexisXMLRequest as txr
        self.failUnless(txr.__version__)
        self.failUnless(txr.__doc__)
        

if __name__ == '__main__':
    framework()
else:
    from unittest import TestSuite, makeSuite
    def test_suite():
        suite = TestSuite()
        suite.addTest(makeSuite(TestTexisXMLRequest))
        return suite

